## mingw-w64-viskores-1.0.0-1.src.tar.zst

=== tutorial/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

#add the directory that contains the Viskores config file to the cmake
#path so that our tutorial can find Viskores
#Normally when running CMake, you need to set the Viskores_DIR to
#find the ViskoresConfig.cmake file. Because we already know where this
#file is, we can add the location to look to CMAKE_PREFIX_PATH.
set(CMAKE_PREFIX_PATH ${Viskores_BINARY_DIR}/${Viskores_INSTALL_CONFIG_DIR})

cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(Viskores_tut)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)


if (Viskores_ENABLE_TUTORIALS)
 # Viskores tutorial targets expect viskores libraries to be namespaced with the prefix viskores::.
 # However, as the tutorial can also be built as part of the Viskores code,
 # those prefix are not added to the targets (This happens during the
 # installation). To workaround this issue here, we create IMPORTED libs linking
 # to the viskores libraries used by the tutorial targets with the expected viskores:: prefix.
 viskores_module_get_list(module_list)
 foreach(tgt IN LISTS module_list)
  if(TARGET ${tgt})
   # The reason of creating this phony IMPORTED libraries instead of making
   # ALIAS libraries is that ALIAS libraries are GLOBAL whereas IMPORTED are
   # local at the directory level where they are created. We do not want these
   # phony targets to be visible outside of the tutorial directory.
   viskores_target_mangle(tgt_name_mangled ${tgt})
   add_library("viskores::${tgt_name_mangled}" INTERFACE IMPORTED)
   target_link_libraries("viskores::${tgt_name_mangled}" INTERFACE ${tgt})
  endif()
 endforeach()
endif()

add_executable(io io.cxx)
target_link_libraries(io viskores::io)

add_executable(contour contour.cxx)
target_link_libraries(contour viskores::filter_core viskores::filter_contour viskores::io)

add_executable(contour_two_fields contour_two_fields.cxx)
target_link_libraries(contour_two_fields viskores::filter_core viskores::filter_contour viskores::io)

add_executable(two_filters two_filters.cxx)
target_link_libraries(two_filters viskores::filter_core viskores::filter_contour viskores::io)

add_executable(mag_grad mag_grad.cxx)
target_link_libraries(mag_grad viskores::filter_core viskores::filter_vector_analysis viskores::io)
# Because mag_grad.cxx creates a worklet with code that
# runs on a GPU, it needs additional information.
viskores_add_target_information(mag_grad
  DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
  DEVICE_SOURCES mag_grad.cxx)

if (Viskores_ENABLE_RENDERING)
  add_executable(rendering rendering.cxx)
  target_link_libraries(rendering viskores::io viskores::rendering)
endif ()

add_executable(error_handling error_handling.cxx)
target_link_libraries(error_handling viskores::filter_core viskores::filter_contour viskores::io)

add_executable(logging logging.cxx)
target_link_libraries(logging viskores::io)

add_executable(point_to_cell point_to_cell.cxx)
target_link_libraries(point_to_cell viskores::worklet viskores::filter_core viskores::io)
viskores_add_target_information(point_to_cell
  DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
  DEVICE_SOURCES point_to_cell.cxx)

add_executable(extract_edges extract_edges.cxx)
target_link_libraries(extract_edges viskores::cont viskores::filter_core viskores::filter_contour viskores::worklet viskores::io)
viskores_add_target_information(extract_edges
  DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
  DEVICE_SOURCES extract_edges.cxx)

# Copy the data file to be adjacent to the binaries
file(GENERATE OUTPUT "$<TARGET_FILE_DIR:mag_grad>/data/kitchen.vtk" INPUT "${CMAKE_CURRENT_SOURCE_DIR}/data/kitchen.vtk")

=== docs/users-guide/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

# This module is always loaded so that the example code is compiled as part
# of the test build. However, we only really want to build the document if
# Viskores_ENABLE_USERS_GUIDE is set.
if (NOT Viskores_ENABLE_USERS_GUIDE)
  return()
endif()

set(sphinx_docs
  index.rst
  )

find_package(Sphinx)
if (NOT Sphinx_FOUND)
  message(FATAL_ERROR
    "Could not find Sphinx to build User's Guide. If you want to compile Doxygen without the User's Guide, turn off Viskores_ENABLE_USERS_GUIDE.")
endif()

option(Viskores_USERS_GUIDE_INCLUDE_TODOS
  "When building the Viskores User's Guide, specify whether to include TODO notes." ON)
mark_as_advanced(Viskores_USERS_GUIDE_INCLUDE_TODOS)

# Configuration used in conf.py.
set(doxygen_xml_output_dir "${Viskores_BINARY_DIR}/docs/doxygen/xml")
set(example_directory "${CMAKE_CURRENT_SOURCE_DIR}/examples")
if(Viskores_USERS_GUIDE_INCLUDE_TODOS)
  set(include_todos "True")
else()
  set(include_todos "False")
endif()

sphinx_add_docs(ViskoresUsersGuideHTML
  BUILDER html
  SOURCE_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
  CONF_FILE conf.py
  )
add_dependencies(ViskoresUsersGuideHTML ViskoresDoxygenDocs)

sphinx_add_docs(ViskoresUsersGuideLaTeX
  BUILDER latex
  SOURCE_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/latex
  CONF_FILE conf.py
  )
add_dependencies(ViskoresUsersGuideLaTeX ViskoresDoxygenDocs)

=== docs/users-guide/requirements.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================
alabaster==0.7.13
    # via sphinx
babel==2.13.0
    # via sphinx
breathe==4.35.0
    # via -r requirements.in
certifi==2024.7.4
    # via requests
charset-normalizer==3.3.0
    # via requests
distro==1.8.0
    # via sphinxcontrib-packages
docutils==0.18.1
    # via
    #   breathe
    #   sphinx
    #   sphinx-rtd-theme
idna==3.7
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.6
    # via sphinx
markupsafe==2.1.3
    # via jinja2
packaging==23.2
    # via sphinx
pygments==2.16.1
    # via sphinx
readthedocs-sphinx-search==0.3.2
    # via -r requirements.in
requests==2.32.2
    # via sphinx
snowballstemmer==2.2.0
    # via sphinx
sphinx==7.2.6
    # via
    #   -r requirements.in
    #   breathe
    #   sphinx-rtd-theme
    #   sphinxcontrib-applehelp
    #   sphinxcontrib-devhelp
    #   sphinxcontrib-htmlhelp
    #   sphinxcontrib-jquery
    #   sphinxcontrib-moderncmakedomain
    #   sphinxcontrib-packages
    #   sphinxcontrib-qthelp
    #   sphinxcontrib-serializinghtml
sphinx-rtd-theme==1.3.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.7
    # via sphinx
sphinxcontrib-devhelp==1.0.5
    # via sphinx
sphinxcontrib-htmlhelp==2.0.4
    # via sphinx
sphinxcontrib-jquery==4.1
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-moderncmakedomain==3.27.0
    # via -r requirements.in
sphinxcontrib-packages==1.1.2
    # via -r requirements.in
sphinxcontrib-qthelp==1.0.6
    # via sphinx
sphinxcontrib-serializinghtml==1.1.9
    # via sphinx
urllib3==2.2.2
    # via requests

=== examples/contour_tree/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(ContourTree CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if (TARGET viskores::filter_scalar_topology)
  add_executable(ContourTreeMesh2D ContourTreeMesh2D.cxx)
  target_link_libraries(ContourTreeMesh2D viskores::filter_core viskores::filter_scalar_topology)

  add_executable(ContourTreeMesh3D ContourTreeMesh3D.cxx)
  target_link_libraries(ContourTreeMesh3D viskores::filter_core viskores::filter_scalar_topology)
endif()

=== examples/contour_tree_augmented/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

## Copyright (c) 2018, The Regents of the University of California, through
## Lawrence Berkeley National Laboratory (subject to receipt of any required approvals
## from the U.S. Dept. of Energy).  All rights reserved.
##
## Redistribution and use in source and binary forms, with or without modification,
## are permitted provided that the following conditions are met:
##
## (1) Redistributions of source code must retain the above copyright notice, this
##     list of conditions and the following disclaimer.
##
## (2) Redistributions in binary form must reproduce the above copyright notice,
##     this list of conditions and the following disclaimer in the documentation
##     and/or other materials provided with the distribution.
##
## (3) Neither the name of the University of California, Lawrence Berkeley National
##     Laboratory, U.S. Dept. of Energy nor the names of its contributors may be
##     used to endorse or promote products derived from this software without
##     specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
## ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
## WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
## IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
## INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
## BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
## LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
## OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
## OF THE POSSIBILITY OF SUCH DAMAGE.
##
##=============================================================================
##
##  This code is an extension of the algorithm presented in the paper:
##  Parallel Peak Pruning for Scalable SMP Contour Tree Computation.
##  Hamish Carr, Gunther Weber, Christopher Sewell, and James Ahrens.
##  Proceedings of the IEEE Symposium on Large Data Analysis and Visualization
##  (LDAV), October 2016, Baltimore, Maryland.
##
##  The PPP2 algorithm and software were jointly developed by
##  Hamish Carr (University of Leeds), Gunther H. Weber (LBNL), and
##  Oliver Ruebel (LBNL)
##==============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)

# Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(NOT TARGET viskores::io OR NOT TARGET viskores::filter_scalar_topology)
  # Libraries needed are not built.
  return()
endif()

####################################
# Serial
####################################
add_executable(ContourTree_Augmented ContourTreeApp.cxx)
target_link_libraries(ContourTree_Augmented viskores::filter_scalar_topology viskores::io)
viskores_add_target_information(ContourTree_Augmented
                            DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
                            DEVICE_SOURCES ContourTreeApp.cxx)

option (VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT Off)
mark_as_advanced(VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT)
if (VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT)
  target_compile_definitions(ContourTree_Augmented PRIVATE "DEBUG_PRINT")
endif()

if (TARGET viskores::tbb)
  target_compile_definitions(ContourTree_Augmented PRIVATE "ENABLE_SET_NUM_THREADS")
endif()

####################################
# MPI
####################################
if (Viskores_ENABLE_MPI)
  add_executable(ContourTree_Augmented_MPI ContourTreeApp.cxx)
  target_link_libraries(ContourTree_Augmented_MPI viskores::filter_scalar_topology viskores::io MPI::MPI_CXX)
  viskores_add_target_information(ContourTree_Augmented_MPI
                              MODIFY_CUDA_FLAGS
                              DEVICE_SOURCES ContourTreeApp.cxx)
  target_compile_definitions(ContourTree_Augmented_MPI PRIVATE "WITH_MPI")

  option (VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT Off)
  mark_as_advanced(VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT)
  if (VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT)
    target_compile_definitions(ContourTree_Augmented_MPI PRIVATE "DEBUG_PRINT")
  endif()

  if (TARGET viskores::tbb)
    target_compile_definitions(ContourTree_Augmented_MPI PRIVATE "ENABLE_SET_NUM_THREADS")
  endif()
endif()

=== examples/histogram/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(Histogram CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)
if (Viskores_ENABLE_MPI AND viskores::filter_density_estimate)
  # TODO: this example desperately needs to be updated. The histogram filter has
  # improved immensely since this has originally been written, and the code can
  # be simplified a lot, which will make it more illustrative of using Viskores.
  add_executable(Histogram Histogram.cxx HistogramMPI.h HistogramMPI.cxx)
  target_link_libraries(Histogram PRIVATE viskores::filter_density_estimate MPI::MPI_CXX)
  viskores_add_target_information(Histogram
    DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
    DEVICE_SOURCES HistogramMPI.cxx)
endif()

=== examples/ising/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(IsingModel CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::rendering)
  add_executable(Ising Ising.cxx)
  target_link_libraries(Ising PRIVATE viskores::worklet viskores::rendering)

  viskores_add_target_information(Ising
    DROP_UNUSED_SYMBOLS
    MODIFY_CUDA_FLAGS
    DEVICE_SOURCES Ising.cxx)
endif()

=== examples/logistic_map/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.19 FATAL_ERROR)
project(LogisticMap CXX)

find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::io)
  add_executable(LogisticMap LogisticMap.cxx)
  target_link_libraries(LogisticMap PRIVATE viskores::io)

  viskores_add_target_information(LogisticMap
    DROP_UNUSED_SYMBOLS
    MODIFY_CUDA_FLAGS
    DEVICE_SOURCES LogisticMap.cxx)
endif()

=== examples/mesh_quality/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##=============================================================================
##
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##
##  Copyright 2015 National Technology & Engineering Solutions of Sandia, LLC (NTESS).
##  Copyright 2015 UT-Battelle, LLC.
##  Copyright 2015 Los Alamos National Security.
##
##  Under the terms of Contract DE-NA0003525 with NTESS,
##  the U.S. Government retains certain rights in this software.
##  Under the terms of Contract DE-AC52-06NA25396 with Los Alamos National
##  Laboratory (LANL), the U.S. Government retains certain rights in
##  this software.
##
##=============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(MeshQuality CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::filter_mesh_info AND TARGET viskores::io)
  add_executable(MeshQuality MeshQuality.cxx)
  target_link_libraries(MeshQuality PRIVATE viskores::filter_mesh_info viskores::io)
endif()

=== examples/particle_advection/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(ParticleAdvection CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::filter_flow AND TARGET viskores::io)
  add_executable(Particle_Advection ParticleAdvection.cxx)
  target_link_libraries(Particle_Advection PRIVATE viskores::filter_flow viskores::io)
endif()

=== examples/polyline_archimedean_helix/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(PolyLineArchimedeanHelix CXX)

find_package(Viskores REQUIRED QUIET)

if (TARGET viskores::rendering)
  # TODO: This example should be changed from using the Tube worklet to using
  # the Tube filter (in the viskores::filter_geometry_refinement library). Then
  # compiling it would no longer require a device compiler and the example
  # would generally be simpler.
  add_executable(PolyLineArchimedeanHelix PolyLineArchimedeanHelix.cxx)
  target_link_libraries(PolyLineArchimedeanHelix PRIVATE viskores::rendering)
  viskores_add_target_information(PolyLineArchimedeanHelix
    DROP_UNUSED_SYMBOLS
    MODIFY_CUDA_FLAGS
    DEVICE_SOURCES PolyLineArchimedeanHelix.cxx
    )
endif()

=== examples/smoke_test/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(ViskoresSmokeTest CXX)
include(CTest)

find_package(Viskores REQUIRED)

if(TARGET viskores::source)
  add_executable(smoke_test smoke_test.cxx)
  target_link_libraries(smoke_test PRIVATE viskores::source)

  # Only add this test when this a standalone project
  if (PROJECT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    add_test(NAME SmokeTestInternal COMMAND ${CMAKE_BINARY_DIR}/smoke_test)
  endif()
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=viskores
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.0.0
pkgrel=1
pkgdesc="A visualization library for many-threaded devices. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://github.com/Viskores/viskores'
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-tbb")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-anari-sdk"
             "${MINGW_PACKAGE_PREFIX}-glew")
optdepends=("${MINGW_PACKAGE_PREFIX}-anari-sdk")
source=("https://github.com/Viskores/viskores/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('5bff5bbd747b7662bb4630889960371d06fcc5e5a962d974a898d1883f196eba')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DViskores_INSTALL_CMAKE_MODULE_DIR=lib/cmake \
      -DViskores_CUSTOM_LIBRARY_SUFFIX="" \
      -DViskores_ENABLE_DEVELOPER_FLAGS=OFF \
      -DViskores_ENABLE_GL_CONTEXT=ON \
      -DViskores_ENABLE_ANARI=ON \
      -DViskores_ENABLE_HDF5_IO=ON \
      -DViskores_ENABLE_OPENMP=ON \
      -DViskores_ENABLE_TBB=ON \
      -DViskores_ENABLE_TESTING=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
